void MoveDirectoryTo(string newDir){
  cout << "--------------------------------------------------------" << endl;
  cout << "Moving directory from:" << endl;
  system("pwd");
  cout << "to:" << endl;
  chdir(newDir.c_str());
  system("pwd");
  cout << "--------------------------------------------------------" << endl;


}

TGraph* TWOFNR(double Ex, double Jf, double particleN, double particleL, double particleJ, double Ji, int model_in_A, int model_in_B, int model_out_A){
 
  /* This funciton moves between directories in order to execute TWOFNR */
  /* and as such CANNOT be run on another machine!                      */



  cout << "========================================================" << endl;
  cout << "           BEGINING TWOFNR AUTOMATED PROCESS           " << endl;
  cout << "========================================================" << endl;
  
  //double Ex = 0.0;
  //double Ji = 2.5;
  //double Jf = 0.0;
  double QValue = 5.383 - Ex; //QValue for 19O(d,p)
  double BeamEnergy = 8.0;
  int beamA = 19, beamZ = 8;
//int model_in_A = 6; //JTandy (for now...)
//int model_in_B = 1; //Reid soft core (for now...)
//int model_out_A = 1; //BechettiGreenlees 
//int model_out_A = 2; //ChapelHill 
//int model_out_A = 3; //Menet 
//int model_out_A = 4; //Perey 
//int model_out_A = 5; //JLM
//int model_out_A = 6; //KoningDelaroche 

  string njjj;

  string twofnrDir = "/home/paxman/Programs/twofnr";

  char origDirChar[200];
  getcwd(origDirChar,200);
  string origDir{origDirChar};

  // Moving to TWOFNR directory
  MoveDirectoryTo(twofnrDir);

  // Delete existing tran.jjj and 24.jjj files
  remove("tran.jjj");
  remove("24.jjj");

  // Fill in.front file
  ofstream frontinput("in.front");
  /* name */ 				frontinput << "jjj" << endl;
  /* label */				frontinput << "auto" << endl;
  /* reaction - here (d,p) */		frontinput << 2 << endl;
  /* calcualte entrance DW */		frontinput << 0 << endl;
  /* calcualte exit DW */		frontinput << 0 << endl;
  /* beam energy per nucleon */		frontinput << BeamEnergy << endl;
  /* beam A, Z */			frontinput << beamA << " " << beamZ << endl;
  /* default integration range */ 	frontinput << 1 << endl;
  /* default number of partial waves */	frontinput << 1 << endl;
  /* default c.o.m steps */		frontinput << "0 0 0" << endl;
  /* L and J of transfered nucleon */	frontinput << particleL << " " << particleJ << endl;
  /* nodes in function (0s,0p,1s...)*/	frontinput << particleN << endl;
  /* calc using reaction Q value */	frontinput << 2 << endl;
  /* input reaction Q value */		frontinput << QValue << endl;
  /* no nonlocality in incident */	frontinput << 1 << endl;
  /* spin, incident channel */		frontinput << Ji << endl;
  /* use built-in potentials */		frontinput << 1 << endl;
  /*** select deut potential ***/	frontinput << model_in_A << endl;
  if(model_in_A==6){
  /*** select deut potential ***/	frontinput << model_in_B << endl;
  }
  /* no nonlocality in outgoing */	frontinput << 1 << endl;
  /* spin, outgoing channel */		frontinput << Jf << endl;
  /* use built-in potentials */		frontinput << 1 << endl;
  /*** select prot protential ***/	frontinput << model_out_A << endl;
  /*** switch case is to keep second selection consistent with first ***/
  switch(model_out_A){
    case 1:
      frontinput << 1 << endl;
      break;
    case 2:
      frontinput << 2 << endl;
      break;
    case 3:
      frontinput << 2 << endl;
      break;
    case 4:
      frontinput << 2 << endl;
      break;
    case 5:
      frontinput << 3 << endl;
      break;
    case 6:
      frontinput << 4 << endl;
      break;
  }
  /* default <p|d> vertex value */	frontinput << 1 << endl;
  /* use that value */			frontinput << 1 << endl;
  /* use zero range <d|p> vertex */	frontinput << 1 << endl;
  /* default neutron binding potent. */	frontinput << "1.25 0.65" << endl;
  /* default spin-orbit strengh */	frontinput << 6.0 << endl;
  /* default bound st. non-locality */	frontinput << 0 << endl;
  /* default bound st. s-o radius */	frontinput << 0 << endl;

  // Close in.front file
  frontinput.close();

  // Execute front20
  string exec_front = "(exec ";
  exec_front.append(twofnrDir);
  exec_front.append("/front20 < in.front > /dev/null)");

  cout << "Executing: " << exec_front << endl;
  system(exec_front.c_str());

  ifstream checkfront("tran.jjj");
  if(!checkfront){
    cout << "!!! ERROR !!! -> front20 failed" << endl;
    return 0;
  } else {
    cout << "front20 execution complete" << endl;
    checkfront.close();
  }


  // Fill in.twofnr file
  ofstream twofnrinput("in.twofnr");
  twofnrinput << "tran.jjj" << endl;
  twofnrinput.close();

  // Execute twofnr20
  string exec_twofnr = "(exec ";
  exec_twofnr.append(twofnrDir);
  exec_twofnr.append("/twofnr20 < in.twofnr > /dev/null)");

  cout << "Executing: " << exec_twofnr << endl;
  system(exec_twofnr.c_str());

  ifstream checktwofnr("24.jjj");
  if(!checktwofnr){
    cout << "!!! ERROR !!! -> twofnr20 failed" << endl;
    return 0;
  } else {
    cout << "twofnr20 execution complete" << endl;
    checktwofnr.close();
  }

  TGraph* DCS_Lab = new TGraph("24.jjj");
  //TGraph* DCS_Lab = new TGraph("21.jjj");
  cout << "Loaded DCS (lab), in units of mb/sr!" << endl;

  // Moving back to working directory
  MoveDirectoryTo(origDir); 


  return DCS_Lab;

}


TGraph* TWOFNR(double Ex, double Jf, double particleN, double particleL, double particleJ, double Ji){
//int model_in_A = 1;  //LohrHaeberli
  int model_in_A = 2;  //PereyPerey
//int model_in_A = 3;  //Daehnick
//int model_in_A = 4;  //Watanabe
//int model_in_A = 5;  //JSoper 
//int model_in_A = 6;  //JTandy 
  int model_in_B = 1;  //Reid soft core

//int model_out_A = 1; //BechettiGreenlees 
//int model_out_A = 2; //ChapelHill 
//int model_out_A = 3; //Menet 
//int model_out_A = 4; //Perey 
//int model_out_A = 5; //JLM
  int model_out_A = 6; //KoningDelaroche 

  TGraph* output = TWOFNR(Ex, Jf, particleN, particleL, particleJ, Ji, model_in_A, model_in_B, model_out_A);
  return output;
}

void TWOFNR_CompareShapes(double Ex){

  TCanvas* twofnr = new TCanvas("twofnr","twofnr",1000,1000);
  twofnr->cd();  twofnr->SetLogy();

  TGraph* s12 = TWOFNR(Ex, 2., 1., 0., 0.5, 2.5);
  TGraph* p12 = TWOFNR(Ex, 2., 0., 1., 0.5, 2.5);
  TGraph* d52 = TWOFNR(Ex, 0., 0., 2., 2.5, 2.5);
  TGraph* f72 = TWOFNR(Ex, 3., 0., 3., 3.5, 2.5);

  s12->SetLineColor(kRed);    s12->SetLineWidth(2); s12->SetLineStyle(1);
  p12->SetLineColor(kGreen);  p12->SetLineWidth(1); p12->SetLineStyle(7);
  d52->SetLineColor(kBlue);   d52->SetLineWidth(2); d52->SetLineStyle(1);
  f72->SetLineColor(kViolet); f72->SetLineWidth(1); f72->SetLineStyle(7);

  s12->Draw();
  p12->Draw("same");
  d52->Draw("same");
  f72->Draw("same");

  auto legend = new TLegend(0.6,0.1,0.9,0.9);
  legend->AddEntry(s12,"s1/2","L");
  legend->AddEntry(p12,"p1/2","L");
  legend->AddEntry(d52,"d5/2","L");
  legend->AddEntry(f72,"f7/2","L");
  legend->Draw();

}

void TWOFNR_CompareSwaves(double Ex){
  //int model_in_A = 5; //JSoper + B
  //int model_in_A = 6; //JTandy + B

  //int model_in_B = 1; //Reid soft core
  //int model_in_B = 2; //Hulthen S+D
  //int model_in_B = 3; //Hulthen S
  //int model_in_B = 4; //AV18
  
  //int model_out_A = 1; //BechettiGreenlees 
  //int model_out_A = 2; //ChapelHill 
  //int model_out_A = 3; //Menet 
  //int model_out_A = 4; //Perey 
  //int model_out_A = 5; //JLM
  //int model_out_A = 6; //KoningDelaroche 

  // === Constant deuteron, changing proton ===
//TCanvas* c1 = new TCanvas();
//TGraph* x_BG = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 1);  x_BG->SetTitle("x_BG");
//TGraph* x_CH = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 2);  x_CH->SetTitle("x_CH");
//TGraph* x_Me = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 3);  x_Me->SetTitle("x_Me");
//TGraph* x_Pe = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 4);  x_Pe->SetTitle("x_Pe");
//TGraph* x_KD = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 6);  x_KD->SetTitle("x_KD");
//
//x_BG->Draw("CA PLC PFC");
//x_CH->Draw("PC PLC PFC");
//x_Me->Draw("PC PLC PFC");
//x_Pe->Draw("PC PLC PFC");
//x_KD->Draw("PC PLC PFC");
//
//gPad->BuildLegend();

  // === Change deuteron B, constant proton ===
  TCanvas* c2 = new TCanvas();
  TGraph* JT_Reid_Perey = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 4);  JT_Reid_Perey->SetTitle("JT_Reid_Perey");
  TGraph* JS_Reid_Perey = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 5, 1, 4);  JS_Reid_Perey->SetTitle("JS_Reid_Perey");
  TGraph* JT_Reid_KnDel = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 6);  JT_Reid_KnDel->SetTitle("JT_Reid_KnDel");
  TGraph* JS_Reid_KnDel = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 5, 1, 6);  JS_Reid_KnDel->SetTitle("JS_Reid_KnDel");

  JT_Reid_Perey->Draw("CA PLC PFC");
  JS_Reid_Perey->Draw("PC PLC PFC");
  JT_Reid_KnDel->Draw("PC PLC PFC");
  JS_Reid_KnDel->Draw("PC PLC PFC");

  gPad->BuildLegend();


 
}

void TWOFNR_CompareOpticalPotentials(double Ex){
  TCanvas* c = new TCanvas();
//  c->Divide(2,2);
//
//  /////////////
//
//  c->cd(1);
//  TGraph* JT_Reid_PereyS = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 4);  JT_Reid_PereyS->SetTitle("JT_Reid_Perey");
//  TGraph* JS_Reid_PereyS = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 5, 1, 4);  JS_Reid_PereyS->SetTitle("JS_Reid_Perey");
//  TGraph* JT_Reid_KnDelS = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 6, 1, 6);  JT_Reid_KnDelS->SetTitle("JT_Reid_KnDel");
//  TGraph* JS_Reid_KnDelS = TWOFNR(Ex, 2, 1, 0, 0.5, 2.5, 5, 1, 6);  JS_Reid_KnDelS->SetTitle("JS_Reid_KnDel");
//
//  JT_Reid_PereyS->Draw("CA PLC PFC");
//  JS_Reid_PereyS->Draw("PC PLC PFC");
//  JT_Reid_KnDelS->Draw("PC PLC PFC");
//  JS_Reid_KnDelS->Draw("PC PLC PFC");
//
//  gPad->BuildLegend();
//  
//  /////////////
//
//  c->cd(2);
//  TGraph* JT_Reid_PereyP = TWOFNR(Ex, 2, 0, 1, 0.5, 2.5, 6, 1, 4);  JT_Reid_PereyP->SetTitle("JT_Reid_Perey");
//  TGraph* JS_Reid_PereyP = TWOFNR(Ex, 2, 0, 1, 0.5, 2.5, 5, 1, 4);  JS_Reid_PereyP->SetTitle("JS_Reid_Perey");
//  TGraph* JT_Reid_KnDelP = TWOFNR(Ex, 2, 0, 1, 0.5, 2.5, 6, 1, 6);  JT_Reid_KnDelP->SetTitle("JT_Reid_KnDel");
//  TGraph* JS_Reid_KnDelP = TWOFNR(Ex, 2, 0, 1, 0.5, 2.5, 5, 1, 6);  JS_Reid_KnDelP->SetTitle("JS_Reid_KnDel");
//
//  JT_Reid_PereyP->Draw("CA PLC PFC");
//  JS_Reid_PereyP->Draw("PC PLC PFC");
//  JT_Reid_KnDelP->Draw("PC PLC PFC");
//  JS_Reid_KnDelP->Draw("PC PLC PFC");
//
//  gPad->BuildLegend();
//
//  /////////////


//LohrHaeberli
//PereyPerey
//Daehnick
//Watanabe


  c->cd(3);
  TGraph* LH_PereyD      = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 1, 1, 4);  LH_PereyD     ->SetTitle("LH_Perey");
  TGraph* JP_PereyD      = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 2, 1, 4);  JP_PereyD     ->SetTitle("PP_Perey");
  TGraph* Daeh_PereyD    = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 3, 1, 4);  Daeh_PereyD   ->SetTitle("Daeh_Perey");
//TGraph* Wata_PereyD    = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 4, 1, 4);  Wata_PereyD   ->SetTitle("Wata_Perey");
  TGraph* JT_Reid_PereyD = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 6, 1, 4);  JT_Reid_PereyD->SetTitle("JT_Reid_Perey");
  TGraph* JS_Reid_PereyD = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 5, 1, 4);  JS_Reid_PereyD->SetTitle("JS_Reid_Perey");
  TGraph* JT_Reid_KnDelD = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 6, 1, 6);  JT_Reid_KnDelD->SetTitle("JT_Reid_KnDel");
  TGraph* JS_Reid_KnDelD = TWOFNR(Ex, 2, 0, 2, 2.5, 2.5, 5, 1, 6);  JS_Reid_KnDelD->SetTitle("JS_Reid_KnDel");

  LH_PereyD   ->Draw("CA PLC PFC"); 
  JP_PereyD   ->Draw("PC PLC PFC");
  Daeh_PereyD ->Draw("PC PLC PFC");
//Wata_PereyD ->Draw("PC PLC PFC");

  JT_Reid_PereyD->Draw("PC PLC PFC"); //JT_Reid_PereyD->Draw("CA PLC PFC");
  JS_Reid_PereyD->Draw("PC PLC PFC");
  JT_Reid_KnDelD->Draw("PC PLC PFC");
  JS_Reid_KnDelD->Draw("PC PLC PFC");

  gPad->BuildLegend();

//  /////////////
//
//  c->cd(4);
//  TGraph* JT_Reid_PereyF = TWOFNR(Ex, 2, 0, 3, 2.5, 2.5, 6, 1, 4);  JT_Reid_PereyF->SetTitle("JT_Reid_Perey");
//  TGraph* JS_Reid_PereyF = TWOFNR(Ex, 2, 0, 3, 2.5, 2.5, 5, 1, 4);  JS_Reid_PereyF->SetTitle("JS_Reid_Perey");
//  TGraph* JT_Reid_KnDelF = TWOFNR(Ex, 2, 0, 3, 2.5, 2.5, 6, 1, 6);  JT_Reid_KnDelF->SetTitle("JT_Reid_KnDel");
//  TGraph* JS_Reid_KnDelF = TWOFNR(Ex, 2, 0, 3, 2.5, 2.5, 5, 1, 6);  JS_Reid_KnDelF->SetTitle("JS_Reid_KnDel");
//
//  JT_Reid_PereyF->Draw("CA PLC PFC");
//  JS_Reid_PereyF->Draw("PC PLC PFC");
//  JT_Reid_KnDelF->Draw("PC PLC PFC");
//  JS_Reid_KnDelF->Draw("PC PLC PFC");
//
//  gPad->BuildLegend();
//
//  /////////////
//
//
//





}





