#!/bin/bash
cd ~/Programs/nptoolv3/Projects/e775s/analysis;
cmake ./;
make -j6;

#=====================
#====================================================
 #rfile='./InputFiles/e775s.reaction'
 #rfile='./InputFiles/e775s_2024-07-30.reaction'
 #rfile='./InputFiles/e775s_2024-09-06.reaction'
#----------- 
  rfileCD='./InputFiles/e775s_CD_2024-10-30.reaction'
  rfileAu1='./InputFiles/e775s_Au-1_2024-10-30.reaction'
  rfileAu2='./InputFiles/e775s_Au-2_2024-10-30.reaction'
#----------------------------------------------------
 #dfile='./InputFiles/mugast.detector'
 #dfile='./InputFiles/mugast_2024-07-30.detector'
 #dfile='./InputFiles/mugast_2024-09-06.detector'
#----------- 
  dfileCD='./InputFiles/mugast_CD_2024-10-21.detector'
  dfileAu='./InputFiles/mugast_Au_2024-10-21.detector'
#----------------------------------------------------
  cfile='./InputFiles/Calibration.txt'
#====================================================
#=====================

#=====================
#====================================================
# Symbolic link for mugast map
#----------------------------------------------------
# Remove old links
 rm ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastMap.h
 rm ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastReverseMap.h
#----------------------------------------------------
# Link "DATA"
#echo "SYMBOLIC LINK: DATA"
#ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Data_MugastMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastMap.h
#ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Data_MugastReverseMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastReverseMap.h
#----------------------------------------------------
# Link "ORIG"
 echo "SYMBOLIC LINK: ORIG"
 ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Orig_MugastMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastMap.h
 ln -s ~/Programs/nptoolv3/NPLib/Detectors/Mugast/Zanon_Orig_MugastReverseMap.h ~/Programs/nptoolv3/NPLib/Detectors/Mugast/MugastReverseMap.h
#====================================================
#=====================

nptool-rebuildNPL
nptool-rebuildNPS

#=====================
#====================================================
#Analysis -- CD2 Target
  inputCD='./InputFiles/CD.runtotreat'
  outputCD=$1'_CD'
  #npanalysis --definition Exp -R $inputCD -E $rfile -D $dfile -C $cfile -O $outputCD;
  npanalysis --definition Exp --definition CD2 -R $inputCD -E $rfileCD -D $dfileCD -C $cfile -O $outputCD;
  
#Analysis -- CD2+Au Target, first half
  inputAu1='./InputFiles/Au-Section1.runtotreat'
  outputAu1=$1'_Au-1'
  npanalysis --definition Exp --definition Au -R $inputAu1 -E $rfileAu1 -D $dfileAu -C $cfile -O $outputAu1;

#Analysis -- CD2+Au Target, second half
  inputAu2='./InputFiles/Au-Section2.runtotreat'
  outputAu2=$1'_Au-2'
  npanalysis --definition Exp --definition Au -R $inputAu2 -E $rfileAu2 -D $dfileAu -C $cfile -O $outputAu2;

##Analysis -- CD2+Au Target
#  inputAu='./InputFiles/Au.runtotreat'
#  outputAu=$1'_Au'
#  npanalysis --definition Exp --definition Au -R $inputAu -E $rfileAu -D $dfileAu -C $cfile -O $outputAu;

#====================================================
#=====================

